-- main.lua
-- @author - Gerard Purra Teixidó <gerard.purra@gmail.com>

-- HUMP
Gamestate = require 'lib.hump.gamestate'
-- Timer = require 'lib.hump.timer'
Vector = require 'lib.hump.vector-light'
-- Signal = require 'lib.hump.signal'

-- CARGO
-- Assets = require 'lib.cargo.cargo'
 
-- i18n

gamestates = {
    ['menu'] = require 'src.gamestates.menu',
    ['level'] = require 'src.gamestates.level',
    ['over'] = require 'src.gamestates.over',
    ['pause'] = require 'src.gamestates.pause'
}

-- Aspect Ratio
AspectRatio = {}
Canvas = nil

-- love.load - Loads all content used on this stage
function love.load()
    local digitalWidth, digitalHeight = 1080, 608
    local winWidth, winHeight = love.graphics.getWidth(), love.graphics.getHeight()

    local scale_w, scale_h = winWidth / digitalWidth, winHeight / digitalHeight
    local scale = math.min(scale_w, scale_h)
    AspectRatio.scale = scale
    
    AspectRatio.gameWidth = digitalWidth * AspectRatio.scale
	AspectRatio.gameHeight = digitalHeight * AspectRatio.scale

    AspectRatio.canvas = {}
    AspectRatio.canvas.x = math.floor((winWidth / 2) - (AspectRatio.gameWidth / 2))
    AspectRatio.canvas.y = math.floor((winHeight / 2) - (AspectRatio.gameHeight / 2))
	Canvas = love.graphics.newCanvas(
		AspectRatio.gameWidth, AspectRatio.gameHeight
	)
    
    AspectRatio.camera = {}
    AspectRatio.camera.offset_x = (winWidth - digitalWidth) / 2 
    AspectRatio.camera.offset_y = (winHeight - digitalHeight) / 2

	Gamestate.registerEvents()
    Gamestate.switch(gamestates.menu)
end

-- love.update - Updates content on this stage
-- @param dt = Delta Time
function love.update(dt)

end

-- love.resize - Resizes window
-- @param winWidth = width
-- @param winHeight = height
function love.resize(winWidth, winHeight)
    local digitalWidth, digitalHeight = 1080, 608

    local scale_w, scale_h = winWidth / digitalWidth, winHeight / digitalHeight
    local scale = math.min(scale_w, scale_h)
    AspectRatio.scale = scale
    
    AspectRatio.gameWidth = digitalWidth * scale
	AspectRatio.gameHeight = digitalHeight * scale

    AspectRatio.canvas.x = math.floor((winWidth / 2) - (AspectRatio.gameWidth / 2))
    AspectRatio.canvas.y = math.floor((winHeight / 2) - (AspectRatio.gameHeight / 2))
	Canvas = love.graphics.newCanvas(
		AspectRatio.gameWidth, AspectRatio.gameHeight
	)
    
    AspectRatio.camera.offset_x = (winWidth - digitalWidth) / 2 
    AspectRatio.camera.offset_y = (winHeight - digitalHeight) / 2
end

-- love.draw - Draws content of this stage
function love.draw()

end

