-- floor.lua
-- @author Gerard Purra Teixido <gerard.purra@gmail.com>

-- Block = Entity representing a floor
-- @field int x = X coordinate
-- @field int y = Y coordinate
local Block = {
  collider = {},
  is_platform = false
}
local block_mt = { __index = Block }

-- Block.new
-- @param data - data to set
function Block.new( data )
  local instance = data
  return setmetatable(instance, block_mt)
end

-- Block:update(dt)
-- @param dt - Delta Time
-- In case of a moving platform, updates position
function Block:update(dt)

end

-- Block:draw
-- Draws itself if needed
function Block:draw()
  love.graphics.setColor(0, 255, 0, 255)
  love.graphics.rectangle(
    'line',
    self.collider.x, self.collider.y,
    self.collider.w, self.collider.h
  )
end

function Block:isPlatform()
  return self.is_platform
end

return Block
