-- enemy.lua
-- @author Gerard Purra Teixido <gerard.purra@gmail.com>

-- Player = Entity representing the player
-- @field int x = X coordinate
-- @field int y = Y coordinate
-- @field int dx = Direction on X axis (-1, 0. 1)
-- @field int dy = Direction on Y axis (-1, 0. 1)
-- @field int speed = Movement speed (pixels/second)
local Enemy = {
  -- target
  -- position
  x = 0,
  y = 0,
  -- direction
  dx = 0,
  dy = 0,
  -- facing
  facing = 0,
  -- dimensions
  w = 0,
  h = 0,
  -- speed
  current_speed = 0,
  walk_speed = 80,
  run_speed = 200,
  -- state
  current_state = 0,
  -- collider
  collider = nil,
  pushes_top = false,
  pushes_bottom = false,
  pushing_left = false,
  pushing_right = false,
}

local enemy_mt = { __index = Enemy }

function Enemy.new(data)
  local instance = data
  return setmetatable(instance, enemy_mt)
end

function Enemy:move(dx, dy)
  self.x, self.y = self.x + dx, self.y + dy
  self.collider:move(dx, dy)
end

function Enemy:draw()
end

return Enemy
