-- factory.lua
-- @author Gerard Purra Teixido <gerard.purra@gmail.com>

local Messenger = require 'src/utils/messenger'
local Sword = require 'src/entities/weapons/sword'

local WeaponFactory = {
  ['switch'] = {
    ['sword'] = function(data)
      local instance = Sword.new(data)

      local trigger = TriggerManager.hc:rectangle(
        instance.x, instance.y, instance.w, instance.h
      )
      trigger.entity = instance
      trigger.group = Globals.MASK_WEAPON
      trigger.mask = {
        [Globals.MASK_ENEMY] = true
      }
      trigger.is_active = false
      TriggerManager:add(trigger)

      local messenger = Messenger.new()
      trigger.messenger = messenger

      instance.trigger = trigger
      return instance
    end
  }
}

function WeaponFactory.new(entity, data)
  if WeaponFactory.switch[entity] then
    return WeaponFactory.switch[entity](data)
  end
end

return WeaponFactory
