-- sword.lua
-- @author Gerard Purra Teixido <gerard.purra@gmail.com>

local Sword = {
  entity = nil,
  --
  has_hit = false,
  has_finished = true,
  -- position
  x = 0,
  y = 0,
  -- dimensions
  w = 20,
  h = 70,
  -- events
  trigger = nil,
  -- rotate
  rx = 0,
  ry = 0,
  time = 0,
  timeout = 0.8,
}

local sword_mt = { __index = Sword }

function Sword.new(e)
  local instance = { entity = e }
  return setmetatable(instance, sword_mt)
end

function Sword:update(dt)
  while self.trigger.messenger:has_inbox() do
    local message = self.trigger.messenger:read()
    if message.trigger.group == Globals.MASK_ENEMY then
      self.has_hit = true
      -- self.trigger.is_active = false
    end
  end
  self.trigger.messenger:clear()

  self.time = self.time + dt
  if self.time < self.timeout then
    self.trigger:rotate(math.pi / 60, self.rx, self.ry)
  else
    self.trigger.is_active = false
    self.entity.current_state = Globals.PLAYER_STATE_IDDLE
    self.has_finished = true
  end
end

function Sword:moveTo(x, y)
  self.x, self.y = x - self.w, y - self.h
  self.trigger:moveTo(x, y)
end

function Sword:rotate(a, x, y)
  if not x and not y then
    self.trigger:rotate(a, x, y)
  else
    self.trigger:rotate(a)
  end
end

function Sword:reset()
  self.trigger:setRotation(0, self.x, self.y + self.h)
  self.time = 0
  self.angle = 0
  self.trigger.is_active = true
  self.has_finished = false
end

return Sword
