-- messenger.lua
-- @author Gerard Purra Teixido <gerard.purra@gmail.com>

local Messenger = {
  messages = {},
  message_count = 0,
  index = 0
}
local messenger_mt = { __index = Messenger }

function Messenger.new()
  return setmetatable({}, messenger_mt)
end

function Messenger:send(entity)
  self.message_count = self.message_count + 1
  self.messages[self.message_count] = entity
end

function Messenger:has_inbox()
  return self.index < self.message_count
end

function Messenger:read()
  self.index = self.index + 1
  return self.messages[self.index]
end

function Messenger:clear()
  self.message_count = 0
  self.index = 0
end

return Messenger
